<?php

namespace Module\Src;

use Dever;

class Api
{
	public function get_api($page)
	{
		$result = array();
		if ($page > 0) {
			$info = Dever::db('module/page')->one($page);
			if ($info && $info['state'] == 1) {
				if ($info['page_id'] == -1) {
					$param['option_page_id'] = $page;
					$param['option_state'] = 1;
					$page = Dever::db('module/page')->all($param);
					foreach ($page as $k => $v) {
						$result[$v['key']] = $this->getModule($v['id']);
					}
				} else {
					$result = $this->getModule($page);
				}
			}
		}

		return $result;
	}

	public function getM_api($module)
	{
		$result = array();
		if ($module > 0) {
			$module = Dever::db('module/info')->one($module);
			$module = $this->getModuleData($module);
			$result = $module;
		}

		return $result;
	}

	private function getModule($page)
	{
		$result = array();
		if ($page > 0) {
			$param['option_page_id'] = $page;
			$module = Dever::db('module/info')->getAll($param);
			$result = array();
			foreach ($module as $k => $v) {
				$result[$v['key']] = $this->getModuleData($v);
			}
		}

		return $result;
	}

	private function getModuleData($module)
	{
		$data = $result = array();

		$method = 'getModuleData_' . $module['type'];
		$data = $this->$method($module);
		
		if ($data && is_array($data) && $module['num'] > 0) {
			$data = array_slice($data, 0, $module['num']);
		}

		/*
		$result['id'] = $module['id'];
		$result['name'] = $module['name'];
		$result['key'] = $module['key'];
		$result['page_id'] = $module['page_id'];
		$result['type'] = $module['type'];
		$result['code'] = $module['code'];
		$result['define'] = $module['define'];
		$result['num'] = $module['num'];
		if ($module['type'] == 1) {
			$result['data_type'] = explode("\r\n", $module['data_type']);
		}
		*/
		$result = $data;

		return $result;
	}

	private function getModuleData_1($module)
	{
		$data = $this->getData($module['id'], $module['type'], $module['num']);

		return $data;
	}

	private function getModuleData_2($module)
	{
		$id = $module['relate_id'];
		$relate = Dever::load('module/info-one', $id);
		$relate['num'] = $module['num'];
		$data = $this->getModuleData($relate);
		return $data;
	}

	private function getModuleData_3($module)
	{
		$data = $this->getMethod($module['id'], $module['define'], $module['num']);
		return $data;
	}

	private function getModuleData_4($module)
	{
		$data = $this->getMethod($module['id'], $module['code'], $module['num']);
		return $data;
	}

	private function getModuleData_5($module)
	{
		$sql = new Sql($module['id'], $module['code'], $module['sql_method'], $module['num']);
		$data = $sql->data;
		return $data;
	}

	private function getModuleData_6($module)
	{
		$data = $this->getMethod($module['id'], $module['code'], $module['num']);
		return $data;
	}

	private function getData($id, $type = 0, $num)
	{
		$data = Dever::load('module/data-getAllByType', array('option_info_id' => $id));

		return $data;
	}

	private function getMethod($id, $method, $num)
	{
		if (strpos($method, '|')) {
			$temp = explode('|', $method);
			$method = $temp[0];
			parse_str($temp[1], $param);
			foreach ($param as $k => $v) {
				if (!Dever::input($k)) {
					Dever::setInput($k, $v);
				}
			}
		}
		$data = Dever::load($method);

		return $data;
	}

	public function module_api($id)
	{
		if (!$id || $id < 0) {
			return array();
		}
		$type = isset($param['type']) ? $param['type'] : 0;

		$module = Dever::load('module/info-one', $id);

		if ($module) {
			$data = Dever::load('module/data-state', array('option_info_id' => $id, 'option_type' => $type));

			if($module['type'] == 3)
			{
				foreach($data as $k => $v)
				{
					$news = Dever::load('sad/supply-one', $v['source_id']);

					if($news)
					{
						$data[$k]['name'] = $v['name'] ? $v['name'] : $news['name'];
						//$data[$k]['pic'] = isset($v['pic']) && $v['pic'] ? $v['pic'] : $news['pic'];
						//$data[$k]['link'] = $v['link'] ? $v['link'] : Dever::url('news/view?id=' . $news['id'], 'main');
						//$data[$k]['content'] = $v['content'] ? $v['content'] : $news['content'];
					}
				}
			}

			return $data;
		}

		return array();
	}
}
